import 'utils.dart';

enum HeroKey {
  allHeroes,
  ana,
  ashe,
  baptiste,
  bastion,
  brigitte,
  cassidy,
  dva,
  doomfist,
  echo,
  genji,
  hanzo,
  hazard,
  illari,
  juno,
  junkrat,
  junkerqueen('junker-queen'),
  kiriko,
  lifeweaver,
  lucio,
  mauga,
  mei,
  mercy,
  moira,
  orisa,
  pharah,
  ramattra,
  reaper,
  reinhardt,
  roadhog,
  sigma,
  sojourn,
  soldier76('soldier-76'),
  sombra,
  symmetra,
  torbjorn,
  tracer,
  widowmaker,
  winston,
  wreckingball('wrecking-ball'),
  venture,
  zarya,
  zenyatta,
  eemptyy;

  final String? _properName;

  const HeroKey([this._properName]);
  
  String get heroName => _properName ?? name;

  static HeroKey fromString(String value) {
    return HeroKey.values.firstWhere((e) => e.name == value || e._properName == value);
  }
}

enum Locale {
  deDe,
  enGb,
  enUs,
  esEs,
  esMx,
  frFr,
  itIt,
  jaJp,
  koKr,
  plPl,
  ptBr,
  ruRu,
  zhCn;

  @override
  String toString() => toKebabCase(name);

  static Locale fromString(String value) {
    return Locale.values.firstWhere((e) => e.name == value);
  }
}

enum Platform {
  pc,
  console,
}

enum Gamemode {
  quickplay,
  competitive,
}

enum Role {
  tank,
  damage,
  support;

  static Role fromString(String value) {
    return Role.values.firstWhere((e) => e.name == value);
  }
}
